#include <stdlib.h>
#include <stdio.h>
#include <signal.h>

void setSignalHandler();

void atexithandler()
{
   printf(">>>>>> myclass CPP: Process terminating...\n");
}

extern "C" void signalhandler(int sig)
{
   switch(sig)
   {
      case SIGINT:
         printf("\n>>>>>> myclass CPP: SIGINT caught...\n");
         setSignalHandler();
         break;
      case SIGBREAK:
         printf("\n>>>>>> myclass CPP: SIGBREAK caught...\n");
         exit(0);
         break;
      default:
         printf("\n>>>>>> myclass CPP: Unknown signal caught %d\n",sig);
         break;
   }
}

void setSignalHandler()
{
   printf("\n>>>>>> myclass CPP: Installing signal handler...\n");
   if( signal(SIGINT, signalhandler) == SIG_ERR)
      printf(">>>>>> myclass CPP: Error installing SIGINT handler...\n");
   if( signal(SIGBREAK, signalhandler) == SIG_ERR)
      printf(">>>>>> myclass CPP: Error installing SIGBREAK handler...\n");
}

int main(int argc, char* argv[])
{
   printf(">>>>>> myclass CPP: Installing atexit handler...\n");
   if(atexit(atexithandler)!=0)
      printf(">>>>>> myclass CPP: Error installing atexit handler...\n");

   setSignalHandler();
   
   printf(">>>>>> myclass CPP: Falling asleep...\n");
   long i = 0;
   while(true)
   {
      if(i%100000 == 0)
         printf(".");
      i++;
   }
   return 0;
}